## ros-indigo-ubiquity-motor 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ubiquity_motor)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS 
	roscpp 
	geometry_msgs  
	nav_msgs 
	serial 
	hardware_interface 
	controller_manager
	dynamic_reconfigure)
## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS  
	thread)

#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
generate_dynamic_reconfigure_options(
  cfg/PID.cfg
)

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/groovy/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

#######################################
## Declare ROS messages and services ##
#######################################

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
#   Leds.msg
# )

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   Service1.srv
#   Service2.srv
# )

## Generate added messages and services with any dependencies listed here
# generate_messages(
#   DEPENDENCIES
#   std_msgs  # Or other packages containing msgs
# )

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
#  LIBRARIES ubiquity_motor
#  CATKIN_DEPENDS other_catkin_pkg
#  DEPENDS system_lib
)

###########
## Build ##
###########
   	
## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

## Declare a cpp library
add_library(ubiquity_motor
  src/motor_message.cc src/motor_serial.cc src/motor_hardware.cc
)
target_link_libraries(ubiquity_motor
 ${catkin_LIBRARIES}
 ${Boost_LIBRARIES}
)

## Declare a cpp executable
add_executable(motor_node src/motor_node.cc)
add_dependencies(motor_node ${PROJECT_NAME}_gencfg)
target_link_libraries(motor_node
 ubiquity_motor
 ${catkin_LIBRARIES}
 ${Boost_LIBRARIES}
)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
#add_dependencies(controller)

## Specify libraries to link a library or executable target against
#target_link_libraries(motor_node
 # ${catkin_LIBRARIES}
#)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/groovy/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
install(TARGETS ubiquity_motor motor_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

## Mark other files for installation (e.g. launch and bag files, etc.)
# install(FILES
#   # myfile1
#   # myfile2
#   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
# )

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
if(CATKIN_ENABLE_TESTING)

	catkin_add_gtest(ubiquity_motor_message_test
		test/motor_message_test.cc)
	target_link_libraries(ubiquity_motor_message_test  ubiquity_motor ${catkin_LIBRARIES})

	catkin_add_gtest(ubiquity_motor_serial_test
		test/motor_serial_test.cc)
	target_link_libraries(ubiquity_motor_serial_test  ubiquity_motor util ${catkin_LIBRARIES})

endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-indigo-ubiquity-motor (0.5.0-0trusty) trusty; urgency=high

  * **NOTE:** This version drops support for firmware versions before 24
  * Use new 8-byte serial protocol
  * Add support for using dynamic_reconfigure to change PID parameters
  * Add support for setting the deadman timer via a parameter
  * Add support for debug registers, do enable better firmware diagnostics
  * Add support for limit reached warnings from firmware
  * Improved testing, more coverage and cleaner tests
  * Have motor_node explicitly return an exit code
  * Reduce memory allocations caused by resizing vectors
  * Use size_t instead of int for iterating
  * Contributors: Rohan Agrawal, Jim Vaughan

 -- Rohan Agrawal <rohan@aleopile.com>  Sun, 04 Sep 2016 07:00:00 -0000

ros-indigo-ubiquity-motor (0.4.1-0trusty) trusty; urgency=high

  * add support for firmware version 19
  * add support for 0xDD (checksum) error response
  * Make variable name for rejected bytes 'rejected'
  * Reduce memcopy-ing
  * Contributors: Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sat, 09 Apr 2016 07:00:00 -0000

ros-indigo-ubiquity-motor (0.4.0-0trusty) trusty; urgency=high

  * Cleanup deps, have motor_node be linked to shared lib
  * Update Copyright Dates
  * Removed old motor_unit_test
  * Moved motor_message_test
  * Make the serial thread loop at the passed in value instead of always 1000
  * Add interruption point to Serial Thread
  * Comment out serial tests
  * Added motor_serial_tests
  * Always print firmware version
  * fix up code that checks a firmware version response
  * Using Async Spinner instead of roscontrol thread
  * more command grouping
  * reduced unnecessary output locking
    using bool method like tony did with input
  * reduce locking by grouping commands to send together
  * Contributors: Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Tue, 08 Mar 2016 08:00:00 -0000

ros-indigo-ubiquity-motor (0.3.2-0trusty) trusty; urgency=high

  * Many fixes for bad odometery, more robust serial protocol
  * Add code to speed up serial. Major improvements in latency to the motor board
  * Contributors: atp42

 -- Rohan Agrawal <rohan@aleopile.com>  Sat, 28 Nov 2015 08:00:00 -0000

ros-indigo-ubiquity-motor (0.3.1-0trusty) trusty; urgency=high

  * fixed install rules for Cmake
  * added license to test code
  * Contributors: Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Mon, 12 Oct 2015 07:00:00 -0000

ros-indigo-ubiquity-motor (0.3.0-0trusty) trusty; urgency=high

  * Remove annoying debug print
  * Fix numerous PID issues. First, add velocity reporting. Second, fix 10x unit error between specified velocity and actual. Third, make PID parameter changes actually world.
  * actually calling the function now
  * added pid params (hopefully)
  * added more unit tests
  * added some more unit test coverage, b/c I spent half an hour on an avoidable wild goose chase
  * updated unit tests
  * renamed motor command to motor message
  * Contributors: Jim Vaughan, Rohan Agrawal
  * Updated package.xml with new dependencies, bumped version number
  * updated travis button
  * Merge refactoring branch into indigo-devel
  * cleaned up some stuff, and got odometery running
  * added odom, and changed loop rates
  * using the correct tics to radians, and now at 20hz
  * cleaned up travis file
  * forgot to remove bad include
  * moved control loop to seperate thread to make it work
  * converted branch to the indigo-devel code
  * added missing ubiquity_motor.cpp
  * changed logging from the output speeds to the input speeds
  * whoops, fotgot to remove typedef for chrono
  * removed boost_chrono dependency, less dependencies is better right
  * explictly apt-get boost-chrono
  * manually installing boost in travis
  * changed travis notfications for slack
  * Fix issue where serial data wouldn't print
    Using a pointer for the motors object in the Motor Serial class, this allows for the initalization to be in the constructer.
  * added slack integration to travis
  * add slack intergration to travis
  * working on making diff_drive_controller work
  * fixed boost expection error
  * Print ros_error on catch for better debugging
  * worked on serial thread loop
  * fix test
  * more exception handling in thread
  * added baud rate switch/case to prevent invalid bauds
  * basic serial thread working
  * change testsuite naming to ubiquity_motor_CLASS
  * added catkin_make to travis because build errors fixed
  * added mutexed add and get command functions
  * added test cases for invalid type/register
  * put header ifndef in motor_serial header
  * redid motor_serial header with boost threads and std::queues
  * added enum checking to getters and setters
  * added deserialize verification
  * started added comments to the code
  * removed unnessary imports
  * added incorrect checksum test case
  * added deserialize funtionality and test
  * added serialize and checksum functions
  * fix typo in travis file
  * changed travis config to run the tests
  * added tests for motor command class
  * Started adding unit tests
  * fixed enum scoping errors
  * fix wierd git problem
  * renamed source files to follow ROS standard practices
  * removed old files that we are not going to use
  * changed motor command class to use new serial protocol spec
  * testing build
  * Merge pull request #2 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/2> from jim-v/hydro
    Added child_frame_id to odom messages.
  * Added child_frame_id to odom messages.
  * Changed MotorDriver to MotorHardware
  * added missing dependencies to package.xml to fix build errors
  * Update README.md
  * added header for motor driver class
  * Merge pull request #1 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/1> from jim-v/hydro
    Added covariance to the outgoing odom messages.
  * Added covariance to the outgoing odom messages.
  * removed old node files
  * added serial dependency to package.xml


=== debian/control ===
Source: ros-indigo-ubiquity-motor
Section: misc
Priority: extra
Maintainer: Rohan Agrawal <rohan@aleopile.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-controller-manager, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-hardware-interface, ros-indigo-nav-msgs, ros-indigo-roscpp, ros-indigo-serial, ros-indigo-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-ubiquity-motor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-controller-manager, ros-indigo-diff-drive-controller, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-hardware-interface, ros-indigo-joint-state-controller, ros-indigo-nav-msgs, ros-indigo-serial, ros-indigo-tf
Description: Provides a ROS interface to Ubiquity Robotics Magni motor controllers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-ubiquity-motor//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
